function World(){
  this.objects = [];
  this.frame = 0;
  this.addObject = function(object){
    this.objects.push(object);
  }
  this.nextFrame = function(){
    this.frame += 1;
    for(var i = 0;i < this.objects.length;i++){
      this.objects[i].update(this.frame);
    }
  }
}

function FromToMovement(startFrame,endFrame,startX,startY,endX,endY){
  this.sf = startFrame;
  this.ef = endFrame;
  this.sx = startX;
  this.ex = endX;
  this.sy = startY;
  this.ey = endY;
  this.calculateX = function(frame){
    if(this.sf <= frame && this.ef >= frame){
      let velX = (this.ex - this.sx) / (this.ef - this.sf);
      velX = velX * (frame - this.sf);
      return this.sx + velX;
    } else if(this.sf > frame){
      return this.sx;
    } else {
      return this.ex;
    }
  }
  this.calculateY = function(frame){
    if(this.sf <= frame && this.ef >= frame){
      //console.log("WHYYYYYYYYYYY");
      let velY = (this.ey - this.sy) / (this.ef - this.sf);
      velY = velY * (frame - this.sf);
      return this.sy + velY;
    } else if(this.sf > frame){
      return this.sy;
    } else {
      return this.ey;
    }
  }
}

function ShowAndHide(sf,ef){
  this.sf = sf;
  this.ef = ef;
  this.updateShowing = function(frame){
    if(frame > this.sf && frame < this.ef){
      return true;
    } else {
      return false;
    }
  }
}

function Obj(x,y){
  this.behavior = [];
  this.x = x;
  this.y = y;
  this.visible = true;
  this.update = function(frame){
    for(var j = 0;j < this.behavior.length;j++){
      if(this.behavior[j] instanceof FromToMovement){
        this.x = this.behavior[j].calculateX(frame);
        this.y = this.behavior[j].calculateY(frame);
      } else if(this.behavior[j] instanceof ShowAndHide){
        this.visible = this.behavior[j].updateShowing(frame);
      }
    }
  }
}
