import { BrowserModule } from '@angular/platform-browser';
import { environment } from './../environments/environment';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { AngularFireModule } from 'angularfire2';
import { AngularFireDatabaseModule } from 'angularfire2/database';

import { AppComponent } from './app.component';
import { HomeComponent } from './home/home.component';
import { IntroComponent } from './intro/intro.component';
import { GameComponent } from './game/game.component';
import { MorseService } from './morse.service';

@NgModule({
  declarations: [
    AppComponent,
    HomeComponent,
    IntroComponent,
    GameComponent
  ],
  imports: [
    BrowserModule,
    AngularFireModule.initializeApp(environment.firebase),
    AngularFireDatabaseModule,
    RouterModule.forRoot([
      {path: '', component: HomeComponent},
      {path: 'intro', component: IntroComponent},
      {path: 'game/:phraseIdx/:sender', component: GameComponent},
      {path: 'game/:phraseIdx', component: GameComponent},
      {path: 'game', component: GameComponent}/*,
      {path: '**', component: HomeComponent}*/
    ])
  ],
  providers: [MorseService],
  bootstrap: [AppComponent]
})
export class AppModule { }
