import { Router } from '@angular/router';
import { Component, OnInit } from '@angular/core';

@Component({
  selector: 'app-home',
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.css']
})
export class HomeComponent implements OnInit {

  bulbOn = false;
  bulbCounter = 0;
  activeBulb = 0; // 0 - left, 1 - right

  constructor(private router: Router) { }

  ngOnInit() {
    setTimeout(() => this.sosBulb(), Math.max(3000, Math.random()*5000));
  }

  sosBulb() {
    this.bulbOn = !this.bulbOn;
    this.bulbCounter++;
    let wait = 500;

    if(this.bulbOn) {
      wait = (this.bulbCounter >= 6 && this.bulbCounter <= 12) ? 3*wait : wait;
    }
    else {
      wait = 800;
    }

    if(this.bulbCounter >= 18) {
      wait = Math.max(5000, Math.random()*10000);
      this.activeBulb = this.activeBulb ? 0 : 1;
      this.bulbCounter = 0;
    }

    setTimeout(() => this.sosBulb(), wait);
  }

  get leftBulbOn(): boolean {
    return this.activeBulb === 0 && this.bulbOn;
  }

  get rightBulbOn(): boolean {
    return this.activeBulb === 1 && this.bulbOn;
  }

  onIntroClicked() {
    window.location.href = 'intro/index.html';
    //this.router.navigateByUrl('intro/index.html');
  }

  onPlayClicked() {
    this.router.navigate(['game']);
  }

}
